#!/bin/bash
set -e

array_file_name="public_gh_secure_COPYNUMBER_MAT.tar.gz"
array_data_path="/public/data/tickets/sdb6088/$array_file_name"
scratch_path=$TESTDIR/$HPID

# create the scratch area for this script, copy the sample data
# into the scratch path, then load the data
rm -rf $scratch_path
mkdir -p $scratch_path
pushd $scratch_path 2>&1 > /dev/null
cp -r $array_data_path .
tar xzf $array_file_name
scidb_backup.py -r opaque $scratch_path/gh_secure_COPYNUMBER_MAT
popd 2>&1 > /dev/null

# demonstrate that the array was loaded successfully
iquery -aq "show(gh_secure_COPYNUMBER_MAT)"
echo "Data loaded successfully"

exit 0
